Subject: Re: [PATCH net-next 00/15] Simplify netfilter and network namespaces

From: [email-masked] (Eric W. Biederman)
Date: Fri, 19 Jun 2015 09:24:45 -0500

Julian Anastasov <[email-masked]> writes:

> 	Hello,
>
> On Thu, 18 Jun 2015, Eric W. Biederman wrote:
>
>> My incremental patch for ipvs on top of everything else I have pushed
>> out looks like this:
>> 
>> From: "Eric W. Biederman" <[email-masked]>
>> Date: Fri, 12 Jun 2015 18:34:12 -0500
>> Subject: [PATCH] ipvs: Pass struct net down to where it is needed and used
>> 
>> Pass struct net down to where it is used and stop guessing
>> which network namespace should be used.
>
> 	At first look patch is ok. But I'm not sure
> for the changes in ip_vs_xmit.c. Can you explain in
> 2-3 lines, when can we see different netns? Is it when
> packet is forwarded to output device and it is part from
> another netns?
>
> 	I'm asking because these __ip_vs_get_out_rt*
> calls in ip_vs_xmit.c can reroute packet to another
> device...

The driver was ensure_mtu_is_adequate where in one half
of the function we have skb_net another half we have 
dev_net(dst_skb(skb)->dev).    That is goofy.

That gets replaced by ip_vs_conn_net(cp).

In practice today I don't see that there are differences in
network namespaces today.

Moving forward I hope to be able to route packets out to network devices
in different network namespaces. It is a massive optimization that
doesn't need much code to support.  Once that optimization is in place
deriving the network namespace from the output device will not work.

I believe using ip_vs_conn_net(cp) is a simple rule that is easy to
understand and easy to implement correctly on the output path.

> 	Also, skb_sknet is another candidate for removal.
> But I can take care about it after your changes are
> pushed...

*nod*

Eric
--
To unsubscribe from this list: send the line "unsubscribe netfilter-devel" in